# fix for broken libopeais
%add_findreq_skiplist %_sbindir/gfs_controld
%add_findreq_skiplist %_sbindir/dlm_controld
%add_findreq_skiplist %_sbindir/groupd

Name: cluster
Version: 2.03.09
License: GPLv2 and LGPLv2
Group: System/Base
Summary: Utilities for managing the global filesystem (GFS2)
Release: alt2
Url: http://sources.redhat.com/cluster/wiki/
Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>
Source: %name-%version.tar.gz
Source1: qdiskd.init
Source2: cluster.sysconfig
Patch: group-rpath.patch
Patch1: fix-cman-init.patch
Patch2: fix-rgmanager-init.patch

# Automatically added by buildreq on Sun Nov 09 2008
BuildRequires: libncurses-devel libslang2-devel libvolume_id-devel libxml2-devel
BuildRequires: perl-Net-Telnet perl-Net-SNMP perl-XML-LibXML heartbeat
BuildRequires: libopenais-devel < 0.82

%description
gfs kernel module and userspace utilities
gfs2 userspace utilities
dlm userspace utilities
cman (cluster infrastructure, various pieces)
fence (i/o fencing)
rgmanager (HA, app failover)
gnbd kernel and userspace (network block device)

%define module_name1 gfs
%define module_version1 %version
%define module_release1 %release
%define module_source1 %module_name-%module_version.tar.gz
%define module_source_dir1 %module_name-%module_version

%package -n kernel-source-%module_name1-%module_version1
Summary: Linux %module_name1 modules sources
Group: Development/Kernel
BuildArch: noarch

%description -n kernel-source-%module_name1-%module_version1
%module_name1 modules sources for Linux kernel

##############################################################
%define module_name2 gnbd
%define module_version2 %version
%define module_release2 %release
%define module_source2 %module_name-%module_version.tar.gz
%define module_source_dir2 %module_name-%module_version

%package -n kernel-source-%module_name2-%module_version2
Summary: Linux %module_name2 modules sources
Group: Development/Kernel
BuildArch: noarch

%description -n kernel-source-%module_name2-%module_version2
%module_name2 modules sources for Linux kernel

##############################################################
%package -n gfs-utils
Group: System/Kernel and hardware
Summary: Global Filesystem Utilities

%description -n gfs-utils
Global Filesystem Utilities

%package -n gfs2-utils
Summary: Utilities for managing the global filesystem (GFS2)
Group: System/Base

%description -n gfs2-utils
The gfs2-utils package contains a number of utilities for creating,
checking, modifying, and correcting any inconsistencies in GFS2
filesystems.

%package -n cman
Summary: CMAN - The Cluster Manager
Group: System/Servers
Requires: libcman = %version-%release
Requires: libdlm = %version-%release
Requires: fence = %version-%release
Requires: %name = %version-%release
Requires: libopenais < 0.82
Provides: ccs = %version
Obsoletes: ccs

%description -n cman
CMAN - The Cluster Manager

%package -n libcman
Group: System/Libraries
Summary: CMAN - The Cluster Manager development package

%description -n libcman
CMAN - The Cluster Manager library package

%package -n libcman-devel
Group: Development/Other
Summary: CMAN - The Cluster Manager development package
Requires: libcman = %version-%release

%description -n libcman-devel
CMAN - The Cluster Manager development package

%package -n libdlm
Summary: Shared Librairies for the Distributed Lock Manager
Group: System/Libraries

%description -n libdlm
Shared Librairies for cluster

%package -n libdlm-devel
Summary: Distributed Lock Manager header files and static libraries
Group: Development/Other
Requires: libdlm = %version

%description -n libdlm-devel
This package contains header files and static libraries.

%package -n rgmanager
Summary: Open Source HA Resource Group Failover for Red Hat Enterprise Linux
Group: System/Base

%description -n rgmanager
Red Hat Resource Group Manager provides high availability of critical server
applications in the event of planned or unplanned system downtime.

%package -n fence
Group: System/Base
Summary: fence - The cluster I/O fencing system

%description -n fence
The cluster I/O fencing system (fence) provides fencing agents which connect
to a variety of network power switch/fibre channel switches/etc. to forcibly
remove unresponsive machines from a cluster.

%package -n qdisk
Summary: Red Hat cluster suite - quorum disk manager
Group: System/Servers
Requires: %name = %version-%release

%description -n qdisk
This package is part of the Red Hat Cluster Suite, a complete
high-availability solution.

This package provides only userspace tools for controlling the
quorum disk.
%package -n gnbd-client
Summary: Red Hat cluster suite - global network block device client tools
Group: System/Kernel and hardware

%description -n gnbd-client
This package is part of the Red Hat Cluster Suite, a complete
high-availability solution.

GNBD allows block devices to be used over the network. It is a
modified version of the Linux network block device for use within a cluster
environment.

This package provides userspace tools for running GNBD clients.

%package -n gnbd-server
Summary: Red Hat cluster suite - global network block device server tools
Group: System/Kernel and hardware

%description -n gnbd-server
This package is part of the Red Hat Cluster Suite, a complete
high-availability solution.

GNBD allows block devices to be used over the network. It is a
modified version of the Linux network block device for use within a cluster
environment.

This package provides userspace tools for running GNBD servers.

%package devel
Summary: Cluster Manager header files and static libraries
Group: Development/Other
Requires: libdlm-devel libcman-devel

%description devel
Cluster Manager header files and static libraries

%prep
%setup
%patch0 -p0
%patch1 -p0
%patch2 -p0

%build
./configure \
	--without_kernel_modules \
	--disable_kernel_check \
	--initddir=%_initdir \
	--libdir=%_libdir \
	--libexecdir=%_libdir \
	--release_version=%version
%make_build

%install
mkdir -p %buildroot%_usrsrc/kernel/sources/
mv %module_name1-kernel kernel-source-%module_name1-%module_version1
tar -c kernel-source-%module_name1-%module_version1 | bzip2 -c > \
%buildroot%_usrsrc/kernel/sources/kernel-source-%module_name1-%module_version1.tar.bz2
mv %module_name2-kernel kernel-source-%module_name2-%module_version2
tar -c kernel-source-%module_name2-%module_version2 | bzip2 -c > \
%buildroot%_usrsrc/kernel/sources/kernel-source-%module_name2-%module_version2.tar.bz2
%makeinstall_std

# fix libfence permissions
chmod 0755 %buildroot%_datadir/fence/*.py
chmod 0755 %buildroot%_datadir/fence/telnet_ssl

mkdir -p %buildroot%_sysconfdir/sysconfig
mkdir -p %buildroot%_sysconfdir/cluster
mkdir -p %buildroot/var/log/cluster
# hack. do you know what I can write here?
touch %buildroot%_sysconfdir/sysconfig/cman
touch %buildroot%_sysconfdir/sysconfig/scsi_reserve
touch %buildroot%_sysconfdir/cluster/gnbdimports.conf
touch %buildroot%_sysconfdir/cluster/gnbdexports.conf

rm -f %buildroot%_initdir/qdiskd

install -m755 %SOURCE1 %buildroot%_initdir/qdiskd
install -m644 %SOURCE2 %buildroot%_sysconfdir/sysconfig/cluster

# clean static
# TODO add static lib packages
rm -f %buildroot%_libdir/*.a

%post -n rgmanager
%post_service rgmanager

%preun -n rgmanager
%preun_service rgmanager

%post -n cman
%post_service cman
%post_service scsi_reserve

%preun -n cman
%preun_service cman
%preun_service scsi_reserve

%post -n gfs-utils
%post_service gfs

%preun -n gfs-utils
%preun_service gfs

%post -n gfs2-utils
%post_service gfs2

%preun -n gfs2-utils
%preun_service gfs2

%post -n libdlm -p %post_ldconfig
%postun -n libdlm -p %post_ldconfig

%post -n libcman -p %post_ldconfig
%postun -n libcman -p %post_ldconfig

%post -n qdisk
%post_service qdiskd

%preun -n qdisk
%preun_service qdiskd

%files
%dir %_sysconfdir/cluster
%config(noreplace) %_sysconfdir/sysconfig/*
%dir /var/log/cluster

%files -n kernel-source-%module_name1-%module_version1
%_usrsrc/kernel/sources/kernel-source-%module_name1-%module_version1.tar.bz2

%files -n kernel-source-%module_name2-%module_version2
%_usrsrc/kernel/sources/kernel-source-%module_name2-%module_version2.tar.bz2

%files -n gfs-utils
/sbin/*.gfs
%_sbindir/*.gfs
%_sbindir/gfs_*
%exclude %_sbindir/gfs_controld
%_initdir/gfs
%_man8dir/gfs_*.8.*
%exclude %_man8dir/gfs_controld.8.gz
%_man8dir/gfs.8.*

%files -n gfs2-utils
%_sbindir/*gfs2*
/sbin/*.gfs2
%_initdir/gfs2
%_man8dir/*gfs2*

%files -n cman
%_initdir/cman
%_initdir/scsi_reserve
%config(noreplace) %_sysconfdir/udev/rules.d/*-dlm.rules
%_sbindir/ccs*
%_sbindir/cman*
%_sbindir/dlm*
%_sbindir/gfs_controld
%_sbindir/group*
%_libdir/lcrso/*
%_datadir/snmp/mibs/*
%_man5dir/c*
%_man7dir/*
%_man8dir/ccs*
%_man8dir/cman*
%_man8dir/dlm*
%_man8dir/gfs_controld*
%_man8dir/group*

%files -n libcman
%_libdir/*cman.so.*

%files -n libcman-devel
%_libdir/*cman.so
%_includedir/libcman.h

%files -n libdlm
%_libdir/*dlm*.so.*

%files -n libdlm-devel
%_libdir/*dlm*.so
%_man3dir/*dlm*.3.*
%_includedir/libdlm.h

%files -n rgmanager
%_initdir/rgmanager
%_sbindir/clu*
%_sbindir/rg*
%_datadir/cluster
%_man8dir/clu*

%files -n gnbd-client
%_sysconfdir/cluster/gnbdimports.conf
%_sbindir/gnbd_import
%_sbindir/gnbd_monitor
%_sbindir/gnbd_recvd
%_man8dir/gnbd_import.8*

%files -n gnbd-server
%_sysconfdir/cluster/gnbdexports.conf
%_sbindir/gnbd_clusterd
%_sbindir/gnbd_export
%_sbindir/gnbd_get_uid
%_sbindir/gnbd_serv
%_man8dir/gnbd.8*
%_man8dir/gnbd_export.8*
%_man8dir/gnbd_serv.8*

%files -n fence
%_sbindir/fence*
%_datadir/fence
%_man8dir/fence*

%files -n qdisk
%_initdir/qdiskd
%_sbindir/qdiskd
%_sbindir/mkqdisk
%_man5dir/qdisk.5*
%_man8dir/qdiskd.8*
%_man8dir/mkqdisk.8*

%files devel
%_docdir/%name
%_includedir/ccs.h

%changelog
* Tue Feb 17 2009 Michail Yakushin <silicium@altlinux.ru> 2.03.09-alt2
- fix build with new openais 

* Sun Nov 09 2008 Boris Savelev <boris@altlinux.org> 2.03.09-alt1
- initial build for Sisyphus
